<?php

namespace Bydedi\Security;

class Role
{
    /**
     * @var int
     */
    public $id;
    /**
     * @var string
     */
    public $name;
    /**
     * @var Permission[]
     */
    protected $permissions;

    public function __construct($id = null, $name = null)
    {
        $this->id = $id;
        $this->name = $name;
        $this->permissions = array();
    }

    public function addPermission(Permission $permission)
    {
        $this->permissions[] = $permission;
        return $this;
    }

    public function getPermission()
    {
        return $this->permissions;
    }

    public function havePermission(Permission $permission)
    {
        $perm = $this->findPermission($permission);
        return ($perm instanceof Permission);
    }

    protected function findPermission(Permission $permission)
    {
        foreach ($this->permissions as $perm) {
            if ($permission->id == $perm->id) {
                return $perm;
            }
        }

        return false;
    }
}