<?php

namespace Bydedi\Utils\TemplatePlugin;

use Bydedi\Template\AbstractPlugin;
use Bydedi\Utils\Image\Image;

class ImagePlugin extends AbstractPlugin
{

    protected $image;

    public function __construct(Image $image)
    {
        $this->image = $image;
    }

    public function transform($params, $template)
    {

        $options = [];

        if (array_key_exists('width', $params)) {
            $options['resize']['width'] = $params['width'];
        }

        if (array_key_exists('height', $params)) {
            $options['resize']['height'] = $params['height'];
        }

        $response = $this->image->transform($params['src'], $options);

        return '<img src="'.$response.'" />';
    }

    /**
     * @return array : type / alias used in templating / callback (object, name of the method to call)
     */
    public function register()
    {
        return [
            'function',
            'image',
            array($this, 'transform')
        ];
    }
}
